/**
 * AsyncSchoolRecordValidationPTSOAPBindingImpl.java
 *
 */

package org.objectweb.orchestra.demo.asyncSchoolRecordValidation;

import org.objectweb.orchestra.demo.college.RecordInfoType;

/**
 * Implementation class of AsyncSchoolRecordValidationPT.
 * AsyncSchoolRecordValidationPTSOAPBindingImpl.java
 *
 * @author Goulven Le Jeune & Charles Souillard
 * @version
 *
 */
public class AsyncSchoolRecordValidationPTSOAPBindingImpl implements AsyncSchoolRecordValidationPT {

    /**
     * Implementation of initiate method.
     * @param recordInfo - recordInfo
     * @param schoolRecordValidationRequest - schoolRecordValidationRequest
     * @throws java.rmi.RemoteException - ex
     */
    public void initiate(final RecordInfoType recordInfo, final AsyncSchoolRecordValidationRequest schoolRecordValidationRequest)
    throws java.rmi.RemoteException {
        System.out.println("AsyncSchoolRecordValidation Invocation ... ");
        String schoolRecordNb =  recordInfo.getSchoolRecordNb();
        // Callback invocation
        try {
            Class clt = Class.forName("org.objectweb.orchestra.demo.asyncSchoolEnrolment.AsyncSchoolRecordValidationResponse");
            Object asrv = clt.newInstance();
            java.lang.reflect.Method mt = clt.getDeclaredMethod("setSchoolRecordNb", new Class[] {java.lang.String.class});
            mt.invoke(asrv, new Object[] {recordInfo.getSchoolRecordNb()});

            String name = recordInfo.getName();
            if (name.startsWith("d") || name.startsWith("D")) {
                mt = clt.getDeclaredMethod("setValidationResponse", new Class[] {java.lang.String.class});
                mt.invoke(asrv, new Object[] {new String("Name Starting with d are not accepted")});
            } else {
                mt = clt.getDeclaredMethod("setValidationResponse", new Class[] {java.lang.String.class});
                mt.invoke(asrv, new Object[] {new String("OK")});
            }

            System.out.println("AsyncSchoolRecordValidation Callback invocation ... ");
            Class cl = Class.forName(
                    "org.objectweb.orchestra.demo.asyncSchoolEnrolment.AsyncSchoolRecordValidationServiceCallbackBPLocator");
            Object as = cl.newInstance();
            java.lang.reflect.Method m = cl.getDeclaredMethod("getasyncSchoolRecordValidationCallbackPT", null);
            Object ast = m.invoke(as, null);
            cl = ast.getClass();
            m = cl.getDeclaredMethod("onResult", new Class[]{asrv.getClass()});
            m.invoke(ast, new Object[] {asrv});
        } catch (Exception e) {
            e.printStackTrace(System.err);
        }
        System.out.println("AsyncSchoolRecordValidation Termination ... ");

    }
}
