/**
 * OwRestituteResponsePTSOAPBindingImpl.java
 *
 */

package org.objectweb.orchestra.demo.owRestituteResponse;

import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MapMessage;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueReceiver;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class OwRestituteResponsePTSOAPBindingImpl implements org.objectweb.orchestra.demo.owRestituteResponse.OwRestituteResponsePT{
    public void initiate(org.objectweb.orchestra.demo.college.RecordInfoType recordInfo, OwSchoolEnrolmentResponseRestitution schoolEnrolmentResponse) throws java.rmi.RemoteException {
        System.out.println("OwRestituteResponse Invocation ... ");
        String vr = schoolEnrolmentResponse.getValidationResponse() ;
        if ( vr.equals("OK")) {
            String sbcr = schoolEnrolmentResponse.getSchoolBusCompanyResponse() ;
        }

        try {
            Context jndi=new InitialContext();
            Queue queue=(Queue) jndi.lookup("CollegeDemoQueue");
            javax.jms.ConnectionFactory  conFactory = (ConnectionFactory)jndi.lookup("JQCF");
            javax.jms.Connection connection = ((QueueConnectionFactory)conFactory).createQueueConnection();
            javax.jms.Session session = ((QueueConnection)connection).createQueueSession(false,
                    Session.AUTO_ACKNOWLEDGE);
            // Send Message to CollegeDemoQueue to WebApp
            QueueSender prod = ((QueueSession) session).createSender(queue);
            MapMessage message=session.createMapMessage();
            message.setStringProperty("SchoolRecordNb",recordInfo.getSchoolRecordNb());
            message.setString("Name",recordInfo.getName());
            message.setString("FirstName",recordInfo.getFirstName());
            message.setString("Address",recordInfo.getAddress());
            message.setString("ValidationResponse",schoolEnrolmentResponse.getValidationResponse());
            message.setString("ClassNb",schoolEnrolmentResponse.getClassNb());
            message.setString("SubsidyAgreement",schoolEnrolmentResponse.getSubsidyAgreement());
            message.setString("SchoolBusCompanyResponse",schoolEnrolmentResponse.getSchoolBusCompanyResponse());
            message.setString("SchoolBusDeparture",schoolEnrolmentResponse.getSchoolBusDeparture());
            message.setString("SchoolBusArrival",schoolEnrolmentResponse.getSchoolBusArrival());
            message.setString("SchoolBusCompanyRecordNb",schoolEnrolmentResponse.getBusCompanyRecordNb());

            printResponse(recordInfo, schoolEnrolmentResponse);

            try {
                prod.send(message);
                prod.close();
                session.close();
                connection.close();
                prod = null;
                session = null;
                connection = null;
                message = null;
            } catch (Exception e) {
                e.printStackTrace();
            } // End try Send
        } catch (Exception e) {
            e.printStackTrace();
        } //end global try
        System.out.println("OwRestituteResponse Termination ... ");
    }

    private void printResponse(org.objectweb.orchestra.demo.college.RecordInfoType recordInfo, OwSchoolEnrolmentResponseRestitution schoolEnrolmentResponse) {
        System.out.println("OwRestituteResponse Sending Response :");
        System.out.println("SchoolRecordNb : " + recordInfo.getSchoolRecordNb());
        System.out.println("Name : " +recordInfo.getName());
        System.out.println("FirstName : " + recordInfo.getFirstName());
        System.out.println("Address : " + recordInfo.getAddress());
        System.out.println("ValidationResponse : " + schoolEnrolmentResponse.getValidationResponse());
        System.out.println("ClassNb : " + schoolEnrolmentResponse.getClassNb());
        System.out.println("SubsidyAgreement : " + schoolEnrolmentResponse.getSubsidyAgreement());
        System.out.println("SchoolBusCompanyResponse : " + schoolEnrolmentResponse.getSchoolBusCompanyResponse());
        System.out.println("SchoolBusDeparture : " + schoolEnrolmentResponse.getSchoolBusDeparture());
        System.out.println("SchoolBusArrival : " + schoolEnrolmentResponse.getSchoolBusArrival());
        System.out.println("SchoolBusCompanyRecordNb : " + schoolEnrolmentResponse.getBusCompanyRecordNb());
    }

}
