package org.objectweb.orchestra.demos.loanapproval;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.objectweb.orchestra.demos.loanapproval.loan.LoanServiceBP;
import org.objectweb.orchestra.demos.loanapproval.loan.LoanServiceBPLocator;
import org.objectweb.orchestra.demos.loanapproval.loan.LoanServicePT;

import java.io.IOException;
import java.math.BigInteger;

public class LoanApprovalServlet extends HttpServlet {

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        HttpSession session = request.getSession(true);

        String lastName = request.getParameter("lastName");
        String firstName = request.getParameter("firstName");
        BigInteger amount = new BigInteger(request.getParameter("amount"));
        String out = null;
        try {
            LoanServiceBP s = new LoanServiceBPLocator();
            LoanServicePT pt = s.getloanServicePT();
            out = pt.request(firstName,lastName,amount);
	    } catch (Exception e) {
            e.printStackTrace(System.err);
	    }

	    try{
            session.setAttribute("lastName", lastName);
            session.setAttribute("firstName", firstName);
            session.setAttribute("amount", amount.toString());
            session.setAttribute("approval", out);
            String jspPath = "/result.jsp";

            getServletContext().getRequestDispatcher(jspPath).forward(request ,response);
        } catch(ServletException e){
            response.sendError(	HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "ServletException "+e.getMessage());
        }
    }

    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException {
        doGet(request,response);
    }
}