@Echo off
setlocal

set ORCHESTRA=%BPEL_HOME%\bin\nt\orchestra.bat

set COLLEGE=%BPEL_HOME%\Demos\College
set COLLEGE_BUILD=%COLLEGE%\build.xml

set TELECOM=%BPEL_HOME%\Demos\Telecom
set TELECOM_BUILD=%TELECOM%\build.xml
set TELECOM_PROVIDER_BUILD=%TELECOM%\TelecomProviderWebapp\build.xml

set LOAN=%BPEL_HOME%\Demos\LoanApproval
set LOAN_BUILD=%LOAN%\build.xml
set LOAN_WSP_BUILD=%LOAN%\wsp\build.xml

set SN=demos

set MODE=
set HELPARG=false

rem ########################################
rem #           GENERAL DEMO
rem ########################################

set DEMO="null"
if [%1]==[] goto usage
set DEMO=%~1
shift
set CORRECT=KO
if ["%DEMO%"]==["college"] set CORRECT=OK
if ["%DEMO%"]==["telecom"] set CORRECT=OK
if ["%DEMO%"]==["loan"] set CORRECT=OK

if [%CORRECT%]==[OK] goto analyseArgs
goto :EOF


:analyseArgs
set ARG=%~1

if ["%ARG%"]==["install"] set MODE=install
if ["%ARG%"]==["clean"] set MODE=clean
if ["%ARG%"]==["deploy"] set MODE=deploy
if ["%ARG%"]==["config"] set MODE=config
if ["%ARG%"]==["deployExt"] set MODE=deployExt
if ["%ARG%"]==["installAll"] set MODE=installAll
if ["%ARG%"]==["-help"] set HELPARG=true

goto next_arg

:next_arg
shift
if not [%1]==[] goto analyseArgs

if [%MODE%]==[] goto %DEMO%_usage
set CORRECT=KO
if ["%MODE%"]==["install"] set CORRECT=OK
if ["%MODE%"]==["clean"] set CORRECT=OK
if ["%MODE%"]==["deploy"] set CORRECT=OK
if ["%MODE%"]==["deployExt"] set CORRECT=OK
if ["%MODE%"]==["config"] set CORRECT=OK
if ["%MODE%"]==["installAll"] set CORRECT=OK

if [%CORRECT%]==[KO] goto %DEMO%_usage

set MODEHELP=%DEMO%_%MODE%_Help
if [%HELPARG%]==[true] goto %MODEHELP%

goto %DEMO%_%MODE%

:usage
echo Usage : %SN% {demoName} {mode}
echo  Valid names:
echo               college        - college demo
echo               telecom        - telecom demo
echo               loan           - loan demo
echo For additional information on a demo enter %SN% {demoName} -help
goto :EOF


rem ########################################
rem #         COLLEGE DEMO
rem ########################################

:college_install
  ant -buildfile %COLLEGE_BUILD% install
  goto :EOF

:college_clean
  ant -buildfile %COLLEGE_BUILD% clean
  goto :EOF

:college_deploy
  call %COLLEGE%\config\deploy.cmd
  goto :EOF

:college_config
  call %ORCHESTRA% config
  ant -buildfile %COLLEGE_BUILD% config
  goto :EOF

:college_installAll
  call %ORCHESTRA% config
  ant -buildfile %COLLEGE_BUILD% config install
  call %COLLEGE%\config\deploy.cmd
  goto :EOF

:college_install_Help
  echo Install the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:college_clean_Help
  echo Clean the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:college_deploy_Help
  echo Deploy the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:college_config_Help
  echo Configure wsdl files of the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:college_usage
  echo Usage : %SN% %DEMO% {mode}
  echo  Valid modes:
  echo               install        - install the %DEMO% demo
  echo               clean          - clean the %DEMO% demo
  echo               deploy         - deploy the %DEMO% demo
  echo               config         - configure wsdl files of the %DEMO% demo
  echo For additional information on a mode enter %SN% %DEMO% {mode} -help
  goto :EOF

rem ########################################
rem #           END COLLEGE DEMO
rem ########################################


rem ########################################
rem #         TELECOM DEMO
rem ########################################

:telecom_install
  ant -buildfile %TELECOM_BUILD% install
  goto :EOF

:telecom_clean
  ant -buildfile %TELECOM_BUILD% clean
  goto :EOF

:telecom_deploy
  call %TELECOM%\deploy.cmd
  goto :EOF

:telecom_config
  call %ORCHESTRA% config
  ant -buildfile %TELECOM_PROVIDER_BUILD% config
  goto :EOF

:telecom_install_Help
  echo Install the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:telecom_clean_Help
  echo Clean the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:telecom_deploy_Help
  echo Deploy the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:telecom_config_Help
  echo Configure wsdl files of the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:telecom_usage
  echo Usage : %SN% %DEMO% {mode}
  echo  Valid modes:
  echo               install        - install the %DEMO% demo
  echo               clean          - clean the %DEMO% demo
  echo               deploy         - deploy the %DEMO% demo
  echo               config         - configure wsdl files of the %DEMO% demo
  echo For additional information on a mode enter %SN% %DEMO% {mode} -help
  goto :EOF

rem ########################################
rem #         END TELECOM DEMO
rem ########################################

rem ########################################
rem #         LOAN DEMO
rem ########################################

:loan_config
  ant -buildfile %LOAN_BUILD% config
  goto :EOF

:loan_install
  ant -buildfile %LOAN_BUILD% install
  goto :EOF

:loan_clean
  ant -buildfile %LOAN_BUILD% clean
  goto :EOF

:loan_deploy
  ant -buildfile %LOAN_BUILD% deploy
  goto :EOF

:loan_deployExt
  ant -buildfile %LOAN_WSP_BUILD% install-wsp
  goto :EOF

:loan_config_Help
  echo Configure the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:loan_install_Help
  echo Install the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:loan_clean_Help
  echo Clean the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:loan_deploy_Help
  echo Deploy the %DEMO% demo
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:loan_deployExt_Help
  echo Configure wsdl files of the %DEMO% demo external web services
  echo Usage : %SN% %DEMO% %MODE%
  goto :EOF

:loan_usage
  echo Usage : %SN% %DEMO% {mode}
  echo  Valid modes:
  echo               config         - configure the %DEMO% demo
  echo               install        - install the %DEMO% demo
  echo               clean          - clean the %DEMO% demo
  echo               deploy         - deploy the %DEMO% demo
  echo               deployExt      - deploy the %DEMO% demo external web services
  echo For additional information on a mode enter %SN% %DEMO% {mode} -help
  goto :EOF

rem ########################################
rem #         END LOAN DEMO
rem ########################################