package org.objectweb.orchestra.samples.google;

import GoogleSearch.*;

public class GoogleClient {

    public static void main(String [] args) {
        if (args.length == 0) {
            System.out.println(">>>>> ERROR: You must specify a query : e.g Objectweb Orchestra");
        } else {
            String key = "350AsKdQFHKTzyYd29dnnVCrCEC8bdJW";
            String q = getQuery(args);
            int start = 0;
            int maxResults = 10;
            boolean filter = false;
            String restrict = null;
            boolean safeSearch = false;
            String lr = null;
            String ie = null;
            String oe = null;
            try {
                GoogleService es=new GoogleServiceLocator();
                GooglePT ept=es.getgooglePort();
                GoogleSearchResult result = ept.search(key,q,start,maxResults,filter,restrict,safeSearch,lr,ie,oe);
                System.out.println("Result for query : "+ q );
                //System.out.println("documentFiltering : "+result.isDocumentFiltering());
                //System.out.println("searchComments : "+result.getSearchComments());
                System.out.println("estimatedTotalResultsCount : "+result.getEstimatedTotalResultsCount());
                //System.out.println("estimateIsExact : "+result.isEstimateIsExact());
                System.out.println("searchQuery : "+result.getSearchQuery());
                //System.out.println("startIndex : "+result.getStartIndex());
                //System.out.println("endIndex : "+result.getEndIndex());
                //System.out.println("searchTips : "+result.getSearchTips());
                System.out.println("searchTime : "+result.getSearchTime());
                ResultElement[] elems = result.getResultElements();
                int printNb = 10;
                if (elems.length > 0) {
                    System.out.println("\nPrinting first results");
                }
                for (int i=result.getStartIndex();i<elems.length && i<(printNb+result.getStartIndex()) && i<(printNb+result.getEndIndex());i++) {
                    ResultElement elem = elems[i];
                    System.out.println("\nResult number "+i);
                    //System.out.println("  summary : "+elem.getSummary());
                    System.out.println("  URL : "+elem.getURL());
                    System.out.println("  snippet : "+elem.getSnippet());
                    System.out.println("  title : "+elem.getTitle());
                    //System.out.println("  cachedSize : "+elem.getCachedSize());
                    //System.out.println("  relatedInformationPresent : "+elem.isRelatedInformationPresent());
                    //System.out.println("  hostName : "+elem.getHostName());
                    //System.out.println("  directoryTitle : "+elem.getDirectoryTitle());
                }
            } catch (Exception e) {
                e.printStackTrace(System.err);
            }
        }
    }

    private static  String getQuery(String [] args) {
        String query = "";
        for (int i = 0;i<args.length;i++) {
            query += args[i]+" ";
        }
        return query;
    }
}
