package org.objectweb.orchestra.samples.list;
import org.objectweb.orchestra.samples.listExternal.*;

public class ListClient {

    public static void main(String [] args) {
        int argNb = 1;
        if (args.length != argNb) {
            System.out.println(">>>>> ERROR: Number of arguments needed : "+argNb);
            System.out.println("             The first should be an int");
        } else {
            try {
                ListServiceLocator fs=new ListServiceLocator();
                ListPT fpt=fs.getListPort();
                GetPartTypeDescriptions in = new GetPartTypeDescriptions();
                in.setPartType(Integer.parseInt(args[0]));
                GetPartTypeDescriptionsResponse out = fpt.getPartTypeDescriptions(in);
                System.out.println(">>>>> ListClient response received: " + out);
                PartTypeList getPartTypeDescriptionsReturn = out.getGetPartTypeDescriptionsReturn();
                System.out.println(">>>>> count: " + getPartTypeDescriptionsReturn.getCount());
                System.out.println(">>>>> partType: " + getPartTypeDescriptionsReturn.getPartType());
                ArrayOf_tns2_PartTypeDescription partList = getPartTypeDescriptionsReturn.getPartList();
                PartTypeDescription[] items = partList.getItem();
                System.out.println(">>>>> items: " + items);
                System.out.println(">>>>> items.length: " + items.length);
                for (int i=0;i<items.length;i++) {
                    PartTypeDescription item = items[i];
                    System.out.println(">>>>> item["+i+"] = " + item);
                    System.out.println(">>>>> item["+i+"].description = " + item.getDescription());
                    System.out.println(">>>>> item["+i+"].partNumber = " + item.getPartNumber());
                    System.out.println(">>>>> item["+i+"].sellingPrice = " + item.getSellingPrice());
                    System.out.println(">>>>> item["+i+"].size = " + item.getSize());
                }
            } catch (Exception e) {
                e.printStackTrace(System.err);
            }
        }
    }
}
