package org.objectweb.orchestra.samples.marketplace;

import java.lang.*;
import java.math.*;

public class MarketPlaceClient
{
    public static void main(String [] args)
    {
        int argNb = 3;
        if (args.length != argNb) {
            System.out.println(">>>>> ERROR: Number of arguments needed : "+argNb);
            System.out.println(">>>>>        The first should be 'buyer' or 'seller'");
            System.out.println(">>>>>        The second should be a string");
            System.out.println(">>>>>        The third should be an int");
        } else {
            try {
                String who = args[0] + " " + args[1] + " " + args[2];
                PrintStartMsg(who);
                if (args[0].compareTo("buyer")==0){
                    BuyerServiceBP bs=new BuyerServiceBPLocator();
                    BuyerPT bpt=bs.getbuyerPT();
                    String item=args[1];
                    int offer = java.lang.Integer.parseInt(args[2]);
                    String out = bpt.submit(item,offer);
                    PrintStopMsg(who,out);
                } else if (args[0].compareTo("seller")==0){
                    SellerServiceBP ss=new SellerServiceBPLocator();
                    SellerPT spt=ss.getsellerPT();
                    String inventoryItem=args[1];
                    int askingPrice = java.lang.Integer.parseInt(args[2]);
                    String out = spt.submit(inventoryItem,askingPrice);
                    PrintStopMsg(who,out);
                } else {
                    System.out.println(">>>>> ERROR: The first argument must be 'buyer' or 'seller'");
                }
            } catch (Exception e) {
                e.printStackTrace(System.err);
            }
        }
    }

    private static void PrintStartMsg( String who )
    {
        System.out.println(">>>>> MARKETPLACE client (" + who + ") starting...");
    }

    private static void PrintStopMsg( String who, String result )
    {
        System.out.println(">>>>> MARKETPLACE client (" + who + ") response received : " + result );
    }

}
