package org.objectweb.orchestra.tests.load;

import org.objectweb.orchestra.samples.helloworld.*;

public class HelloworldThread extends LoadAbstractThread {

    private HelloWorldServiceBP fs = null;
    private HelloWorld fpt = null;
    private String name = null;
    private InitiateHelloWorldT in = null;

    public HelloworldThread(int nb, int axisTimeOut) {
        super(nb,"helloworld");
        try {
            this.fs=new HelloWorldServiceBPLocator();
            this.fpt=this.fs.getHelloWorld();
            ((HelloWorldPTSOAPBindingStub)this.fpt).setTimeout(axisTimeOut);
            this.in = new InitiateHelloWorldT();
            this.name = "Dupont"+nb;
            this.in.setName(this.name);
        } catch (Exception e) {
            e.printStackTrace(System.err);
        }
    }

    public boolean call() throws Exception {
        boolean success = false;
        InitiateHelloWorldResponseT out = this.fpt.initiate(this.in);
        success = out.getResult().equals("Hello "+this.name);
        return success;
    }

}
