package org.objectweb.orchestra.tests.unit.unitExpr;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitExpr.Expr;
import org.objectweb.orchestra.tests.unit.unitExpr.ExprServiceBP;
import org.objectweb.orchestra.tests.unit.unitExpr.ExprServiceBPLocator;


public class TestExpr extends TestCase {

    private ExprServiceBP fs = null;
    private Expr fpt = null;


    public TestExpr(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestExpr.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.fs = new ExprServiceBPLocator();
        this.fpt = this.fs.getExpr();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestExpr(testtorun));
        }
    }

    public void testExprNum1() throws Exception {
        int i1 = 15;
        int i2 = 4;
        int res = this.fpt.exprnum1(i1, i2, 0, 0, 0);
        assertEquals("_testExprNum1", i1 + i2, res);
    }
    public void testExprNum2() throws Exception {
        int i1 = 15;
        int i2 = 4;
        int res = this.fpt.exprnum2(i1, i2, 0, 0, 0);
        assertEquals("_testExprNum2", i1 + i2, res);
    }
    public void testExprNum3() throws Exception {
        int i1 = 15;
        int i2 = 4;
        int res = this.fpt.exprnum3(i1, i2, 0, 0, 0);
        assertEquals("_testExprNum3", i1 + i2, res);
    }
    public void testExprNum4() throws Exception {
        int i1 = 15;
        int i2 = 4;
        int res = this.fpt.exprnum4(i1, i2, 0, 0, 0);
        assertEquals("_testExprNum4", i1 + i2, res);
    }
    public void testExprNum5() throws Exception {
        int i1 = 15;
        int i2 = 4;
        int res = this.fpt.exprnum5(i1, i2, 0, 0, 0);
        assertEquals("_testExprNum5", i1 + i2, res);
    }

    public void testExprNum6() throws java.rmi.RemoteException {
        int i1 = 15;
        int i2 = 4;
        int i3 = 7;
        int res = this.fpt.exprnum6(i1, i2, i3, 0, 0);
        assertEquals("_testExprNum6", i1*3 + 5*i2 - i3*2 - 4, res);
    }

    public void testExprMod() throws java.rmi.RemoteException {
        int i1 = 5;
        int i2 = 2;
        int res = this.fpt.exprmod(i1, i2, 0, 0, 0);
        assertEquals("_testExprMod1", i1 % i2, res);
        res = this.fpt.exprmod(-i1, -i2, 0, 0, 0);
        assertEquals("_testExprMod2", -i1 % -i2, res);
    }


    public void testExprCmp1() throws java.rmi.RemoteException {
        int i1 = 7;
        boolean res = this.fpt.exprcmp1(i1, i1, 0, 0, 0);
        assertTrue("_testExprCmp1",!res);
    }

    public void testExprStr1() throws java.rmi.RemoteException {
        boolean res = this.fpt.exprstr1("Helene Joanin", "Helene Joanin", "", "", "");
        assertTrue("_testExprStr1",res);
    }


}

