package org.objectweb.orchestra.tests.unit.unitFlow;

import javax.xml.rpc.holders.StringHolder;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitFlow.Flow;
import org.objectweb.orchestra.tests.unit.unitFlow.FlowServiceBP;
import org.objectweb.orchestra.tests.unit.unitFlow.FlowServiceBPLocator;


public class TestFlow extends TestCase {

    private boolean tmp;

    private FlowServiceBP fs = null;
    private Flow fpt = null;

    String st = new String("startFlow");
    StringHolder var1 = new StringHolder();
    StringHolder var2 = new StringHolder();
    StringHolder var3 = new StringHolder();
    StringHolder var4 = new StringHolder();
    StringHolder var5 = new StringHolder();
    StringHolder var6 = new StringHolder();
    StringHolder var7 = new StringHolder();

    public TestFlow(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestFlow.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.fs = new FlowServiceBPLocator();
        this.fpt = this.fs.getFlow();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestFlow(testtorun));
        }
    }

    public void testFlow() throws Exception {
        this.fpt.start(this.st,this.var1,this.var2,this.var3,this.var4,this.var5,this.var6,this.var7);
        this.tmp = this.var1.value.equals("FlowSequenceB");
        assertTrue("Flow error, var1 = "+this.var1.value+", instead of : FlowSequenceB",this.tmp);
        this.tmp = this.tmp && this.var2.value.equals("10");
        assertTrue("Flow error, var2 = "+this.var2.value+", instead of : 10",this.tmp);
        this.tmp = this.tmp && this.var3.value.equals("ABCGEFD");
        assertTrue("Flow error, var3 = "+this.var3.value+", instead of : ABCGEFD",this.tmp);
        this.tmp = this.tmp && this.var4.value.equals("ABCDFEG");
        assertTrue("Flow error, var4 = "+this.var4.value+", instead of : ABCDFEG",this.tmp);
        this.tmp = this.tmp && this.var5.value.equals("ABCDFE");
        assertTrue("Flow error, var5 = "+this.var5.value+", instead of : ABCDFE",this.tmp);
        this.tmp = this.tmp && this.var6.value.equals("ABCJINKML");
        assertTrue("Flow error, var6 = "+this.var6.value+", instead of : ABCJINKML",this.tmp);
        this.tmp = this.tmp && this.var7.value.equals("ABCJINKM");
        assertTrue("Flow error, var7 = "+this.var7.value+", instead of : ABCJINKM",this.tmp);
    }


}



