package org.objectweb.orchestra.tests.unit.unitIf;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitIf.UnitIfPT;
import org.objectweb.orchestra.tests.unit.unitIf.UnitIfServiceBP;
import org.objectweb.orchestra.tests.unit.unitIf.UnitIfServiceBPLocator;



public class TestIf extends TestCase {

    private boolean tmp;

    private UnitIfServiceBP fs = null;
    private UnitIfPT fpt = null;

    private String cas = null;
    private String st = null;
    private int integer;
    private boolean boole;
    private boolean boole2;
    private String message = null;

    public TestIf(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestIf.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.message = null;
        this.fs = new UnitIfServiceBPLocator();
        this.fpt = this.fs.getunitIfPT();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestIf(testtorun));
        }
    }

    public void testIf1() throws Exception {
        //<case condition="getVariableData('in','st')='if1'">
        this.cas = "1";
        this.st = "if1";
        this.integer = 1;
        this.boole = false;
        this.boole2 = false;
        this.message = this.fpt.if1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK1 "+this.st);
        assertTrue("if1 error",this.tmp);
    }

    public void testIf2() throws Exception {
        //<case condition="getVariableData('in','integer')=1">
        this.cas = "1";
        this.st = "if2";
        this.integer = 1;
        this.boole = false;
        this.boole2 = false;
        this.message = this.fpt.if1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK2 "+this.st);
        assertTrue("if2 error",this.tmp);
    }

    public void testIf3() throws Exception {
        //<case condition="getVariableData('in','boole2')">
        this.cas = "1";
        this.st = "if3";
        this.integer = 3;
        this.boole = true;
        this.boole2 = true;
        this.message = this.fpt.if1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK3 "+this.st);
        assertTrue("if3 error",this.tmp);
    }

    public void testIf4() throws Exception {
        //<case condition="getVariableProperty('in','bool')">
        this.cas = "1";
        this.st = "if4";
        this.integer = 3;
        this.boole = true;
        this.boole2 = false;
        this.message = this.fpt.if1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK4 "+this.st);
        assertTrue("if4 error",this.tmp);
    }

    public void testIf5() throws Exception {
        //It must not choose this case : <case condition="getVariableData('in','boole') != getVariableData('in','boole2')">
        //<case condition="getVariableData('in','boole') = getVariableData('in','boole2')">
        this.cas = "1";
        this.st = "if5";
        this.integer = 3;
        this.boole = false;
        this.boole2 = false;
        this.message = this.fpt.if1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK6 "+this.st);
        assertTrue("if5 error",this.tmp);
    }

    public void testIf6() throws Exception {
        //It must not choose this case<case condition="getVariableData('in','cas')='1'">
        //<otherwise>
        this.cas = "2";
        this.st = "if6";
        this.integer = 3;
        this.boole = false;
        this.boole2 = false;
        this.message = this.fpt.if1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK7 "+this.st);
        assertTrue("if6 error",this.tmp);
    }

}



