package org.objectweb.orchestra.tests.unit.unitInvokeFault;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitInvokeFault.InvokeFault;
import org.objectweb.orchestra.tests.unit.unitInvokeFault.InvokeFaultServiceBP;
import org.objectweb.orchestra.tests.unit.unitInvokeFault.InvokeFaultServiceBPLocator;


public class TestInvokeFault extends TestCase {

    private InvokeFaultServiceBP ifs = null;
    private InvokeFault ifpt = null;

    public TestInvokeFault(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestInvokeFault.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.ifs = new InvokeFaultServiceBPLocator();
        this.ifpt = this.ifs.getInvokeFault();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestInvokeFault(testtorun));
        }
    }

    public void testInvokeFault() throws Exception {
        String result = this.ifpt.start("test1");
        boolean tmp = result.equals("my Fault");
        assertTrue("Fault error, return = "+result,tmp);
    }


}



