package org.objectweb.orchestra.tests.unit.unitNamespace;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitNamespace.NamespacePT;
import org.objectweb.orchestra.tests.unit.unitNamespace.NamespaceServiceBP;
import org.objectweb.orchestra.tests.unit.unitNamespace.NamespaceServiceBPLocator;


public class TestNamespace extends TestCase {

    private boolean tmp;

    private NamespaceServiceBP fs = null;
    private NamespacePT fpt = null;

    private String cas = null;
    private int integer;
    private String message = null;

    public TestNamespace(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestNamespace.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.message = null;
        this.fs = new NamespaceServiceBPLocator();
        this.fpt = this.fs.getNamespacePT();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestNamespace(testtorun));
        }
    }

    public void testNamespace() throws Exception {
        this.cas = "1";
        this.integer = 1;
        this.message = this.fpt.namespace1(this.cas,this.integer);
        this.tmp = this.message.equals(this.cas);
        assertTrue("namespace1 error",this.tmp);
    }
}



