package org.objectweb.orchestra.tests.unit.unitRepeatUntil;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitRepeatUntil.UnitRepeatUntilPT;
import org.objectweb.orchestra.tests.unit.unitRepeatUntil.RepeatUntilServiceBP;
import org.objectweb.orchestra.tests.unit.unitRepeatUntil.RepeatUntilServiceBPLocator;


public class TestRepeatUntil extends TestCase {

    private boolean tmp;

    private RepeatUntilServiceBP fs = null;
    private UnitRepeatUntilPT fpt = null;

    private String cas = null;
    private int integer;
    private String message = null;

    public TestRepeatUntil(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestRepeatUntil.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.message = null;
        this.fs = new RepeatUntilServiceBPLocator();
        this.fpt = this.fs.getunitRepeatUntilPT();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestRepeatUntil(testtorun));
        }
    }

    public void testRepeatUntil1() throws Exception {
        this.cas = "1";
        this.integer = 1;
        this.message = this.fpt.repeatUntil1(this.cas,this.integer);
        this.tmp = this.message.equals("repeatUntil10");
        assertTrue("repeatUntil1 error",this.tmp);
    }

       public void testRepeatUntil2() throws Exception {
        this.cas = "2";
        this.integer = 0;
        this.message = this.fpt.repeatUntil1(this.cas,this.integer);
        this.tmp = this.message.equals("repeatUntil00121012201230124012");
        assertTrue("repeatUntil2 error",this.tmp);
    }

         public void testRepeatUntil3() throws Exception {
        this.cas = "3";
        this.integer = 0;
        this.message = this.fpt.repeatUntil1(this.cas,this.integer);
        this.tmp = this.message.equals("hello");
        assertTrue("repeatUntil3 error",this.tmp);
    }

    public void testRepeatUntil4() throws Exception {
        this.integer = 200;
        this.message = this.fpt.repeatUntil2(this.integer);
        String mySt = "seqB";
        for (int i=this.integer;i>0;i--) {
            mySt += new Integer(i).toString();
        }
        mySt += "seqC";
        this.tmp = this.message.equals(mySt);
        assertTrue("repeatUntil4 error",this.tmp);
    }

}



