package org.objectweb.orchestra.tests.unit.unitSamples;

import org.objectweb.orchestra.samples.marketplace.BuyerPT;
import org.objectweb.orchestra.samples.marketplace.BuyerServiceBP;
import org.objectweb.orchestra.samples.marketplace.BuyerServiceBPLocator;
import org.objectweb.orchestra.samples.marketplace.SellerPT;
import org.objectweb.orchestra.samples.marketplace.SellerServiceBP;
import org.objectweb.orchestra.samples.marketplace.SellerServiceBPLocator;



public class MarketplaceThread extends Thread {

    private BuyerPT bpt = null;
    private SellerPT spt = null;
    private String item = "item";
    private int price = 10000;
    private String type = null;

    public MarketplaceThread(String type) throws Exception {
        this.type = type;
        if (type.equals("buyer")){
            BuyerServiceBP s = new BuyerServiceBPLocator();
            this.bpt = s.getbuyerPT();
        } else if (type.equals("seller")) {
            SellerServiceBP s = new SellerServiceBPLocator();
            this.spt = s.getsellerPT();
        }
    }

    public void run() {
        String out = null;
        try {
            if (this.type.equals("buyer")) {
                out = this.bpt.submit(this.item,this.price);
                TestSamples.outBuyer = out;
            } else if (this.type.equals("seller")) {
                out = this.spt.submit(this.item,this.price);
                TestSamples.outSeller = out;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
