package org.objectweb.orchestra.tests.unit.unitSourceTarget;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitSourceTarget.SourceTarget;
import org.objectweb.orchestra.tests.unit.unitSourceTarget.SourceTargetServiceBP;
import org.objectweb.orchestra.tests.unit.unitSourceTarget.SourceTargetServiceBPLocator;



public class TestSourceTarget extends TestCase {

    private boolean tmp;

    private SourceTargetServiceBP sts = null;
    private SourceTarget stpt = null;


    public TestSourceTarget(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestSourceTarget.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.sts = new SourceTargetServiceBPLocator();
        this.stpt = this.sts.getSourceTarget();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestSourceTarget(testtorun));
        }
    }

    public void testSourceTarget() throws Exception {
        String st = new String("startSourceTarget");
        String result = this.stpt.start1(st);
        this.tmp = result.equals("SourceTarget1");
        assertTrue("SourceTarget error",this.tmp);
    }


}



