package org.objectweb.orchestra.tests.unit.unitSwitch;

import org.objectweb.orchestra.util.BPELConstants;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitSwitch.UnitSwitchPT;
import org.objectweb.orchestra.tests.unit.unitSwitch.UnitSwitchServiceBP;
import org.objectweb.orchestra.tests.unit.unitSwitch.UnitSwitchServiceBPLocator;



public class TestSwitch extends TestCase {

    private boolean tmp;

    private UnitSwitchServiceBP fs = null;
    private UnitSwitchPT fpt = null;

    private String cas = null;
    private String st = null;
    private int integer;
    private boolean boole;
    private boolean boole2;
    private String message = null;

    public TestSwitch(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestSwitch.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.message = null;
        this.fs = new UnitSwitchServiceBPLocator();
        this.fpt = this.fs.getunitSwitchPT();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestSwitch(testtorun));
        }
    }

    public void testSwitch1() throws Exception {
        //<case condition="getVariableData('in','st')='switch1'">
        this.cas = "1";
        this.st = "switch1";
        this.integer = 1;
        this.boole = false;
        this.boole2 = false;
        this.message = this.fpt.switch1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK1 "+this.st);
        assertTrue("switch1 error",this.tmp);
    }

    public void testSwitch2() throws Exception {
        //<case condition="getVariableData('in','integer')=1">
        this.cas = "1";
        this.st = "switch2";
        this.integer = 1;
        this.boole = false;
        this.boole2 = false;
        this.message = this.fpt.switch1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK2 "+this.st);
        assertTrue("switch2 error",this.tmp);
    }

    public void testSwitch3() throws Exception {
        //<case condition="getVariableData('in','boole2')">
        this.cas = "1";
        this.st = "switch3";
        this.integer = 3;
        this.boole = true;
        this.boole2 = true;
        this.message = this.fpt.switch1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK3 "+this.st);
        assertTrue("switch3 error",this.tmp);
    }

    public void testSwitch4() throws Exception {
        //<case condition="getVariableProperty('in','bool')">
        this.cas = "1";
        this.st = "switch4";
        this.integer = 3;
        this.boole = true;
        this.boole2 = false;
        this.message = this.fpt.switch1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK4 "+this.st);
        assertTrue("switch4 error",this.tmp);
    }

    public void testSwitch5() throws Exception {
        //It must not choose this case : <case condition="getVariableData('in','boole') != getVariableData('in','boole2')">
        //<case condition="getVariableData('in','boole') = getVariableData('in','boole2')">
        this.cas = "1";
        this.st = "switch5";
        this.integer = 3;
        this.boole = false;
        this.boole2 = false;
        this.message = this.fpt.switch1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK6 "+this.st);
        assertTrue("switch5 error",this.tmp);
    }

    public void testSwitch6() throws Exception {
        //It must not choose this case<case condition="getVariableData('in','cas')='1'">
        //<otherwise>
        this.cas = "2";
        this.st = "switch6";
        this.integer = 3;
        this.boole = false;
        this.boole2 = false;
        this.message = this.fpt.switch1(this.cas,this.st,this.integer,this.boole,this.boole2);
        this.tmp = this.message.equals("OK7 "+this.st);
        assertTrue("switch6 error",this.tmp);
    }

}



