package org.objectweb.orchestra.tests.unit.unitWait;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.objectweb.orchestra.tests.unit.unitWait.UnitWaitPT;
import org.objectweb.orchestra.tests.unit.unitWait.WaitServiceBP;
import org.objectweb.orchestra.tests.unit.unitWait.WaitServiceBPLocator;


import java.util.Date;
import java.util.Calendar;
import java.util.GregorianCalendar;

import org.objectweb.orchestra.util.BPELConstants;

public class TestWait extends TestCase {

    private boolean tmp;

    private WaitServiceBP fs = null;
    private UnitWaitPT fpt = null;


    private String message;
    private Calendar cal = new GregorianCalendar ();

    public TestWait(String testname) {
        super(testname);
    }

    public static TestSuite suite() {
        return new TestSuite(TestWait.class);
    }

    public void setUp() throws Exception {
        System.out.println(BPELConstants.TEST_MESS_BEGIN+this.getName()+BPELConstants.TEST_MESS_END);
        this.tmp = false;
        this.message = null;
        this.fs = new WaitServiceBPLocator();
        this.fpt = this.fs.getunitWaitPT();
    }

    public static void main(String args[]) {
        String testtorun = null;
        // Get args: <test-name>
        if (args.length > 0) {
            testtorun = args[0];
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new TestWait(testtorun));
        }
    }

    public void testWait1() throws Exception {
        //<wait for="P7S"/>
        String cas = new String("1");
        int integer = 0;
        this.message = this.fpt.wait1(cas,integer);
        this.tmp = this.message.equals("wait1");
        assertTrue("wait1 error",this.tmp);
    }

    public void testWait2() throws Exception {
        //<wait for="getVariableData('in2','duration')"/>
        String dur = new String ("PT7S");
        this.message = this.fpt.wait2(dur);
        this.tmp = this.message.equals("wait2");
        assertTrue("wait2 error",this.tmp);
    }

    public void testWait3() throws Exception {
        //<wait for="getVariableProperty('in2','duration')"/>
        String dur = new String ("PT7S");
        this.message = this.fpt.wait3(dur);
        this.tmp = this.message.equals("wait3");
        assertTrue("wait3 error",this.tmp);
    }

    public void testWait4() throws Exception {
        //<wait until="getVariableData('in3','dateTime')"/>
        this.cal = new GregorianCalendar ();
        this.cal.setTime(new Date());
        this.cal.add(Calendar.SECOND,7);
        this.message = this.fpt.wait4(this.cal);
        this.tmp = this.message.equals("wait4");
        assertTrue("wait4 error",this.tmp);
    }

    public void testWait5() throws Exception {
        //<wait until="getVariableProperty('in3','dateTime')"/>
        this.cal = new GregorianCalendar ();
        this.cal.setTime(new Date());
        this.cal.add(Calendar.SECOND,7);
        this.message = this.fpt.wait5(this.cal);
        this.tmp = this.message.equals("wait5");
        assertTrue("wait5 error",this.tmp);
    }

    public void testWait6() throws Exception {
        //<wait until="getVariableData('in4','time')"/>
        this.cal = new GregorianCalendar ();
        this.cal.setTime(new Date());
        this.cal.add(Calendar.SECOND,7);
        this.message = this.fpt.wait6(this.cal);
        this.tmp = this.message.equals("wait6");
        assertTrue("wait6 error",this.tmp);
    }

    public void testWait7() throws Exception {
        //<wait until="getVariableProperty('in4','time')"/>
        this.cal = new GregorianCalendar ();
        this.cal.setTime(new Date());
        this.cal.add(Calendar.SECOND,7);
        this.message = this.fpt.wait7(this.cal);
        this.tmp = this.message.equals("wait7");
        assertTrue("wait7 error",this.tmp);
    }

    public void testWait8() throws Exception {
        //<wait until="getVariableData('in5','date')"/>
        this.cal = new GregorianCalendar ();
        this.cal.setTime(new Date());
        this.cal.add(Calendar.SECOND,7);
        this.message = this.fpt.wait8(this.cal);
        this.tmp = this.message.equals("wait8");
        assertTrue("wait8 error",this.tmp);
    }

    public void testWait9() throws Exception {
        //<wait until="getVariableProperty('in5','date')"/>
        this.cal = new GregorianCalendar ();
        this.cal.setTime(new Date());
        this.cal.add(Calendar.SECOND,7);
        this.message = this.fpt.wait9(this.cal);
        this.tmp = this.message.equals("wait9");
        assertTrue("wait9 error",this.tmp);
    }

}
